/*
 * @Author: mbw
 * @Date: 2024-12-03 11:13:13
 * @LastEditors: mbw && 1600520629@qq.com
 * @LastEditTime: 2024-12-15 17:16:45
 * @FilePath: \ble_-tyq_-bjq_-ch584-m\APP\multiCentral_main.c
 * @Description:
 *
 * Copyright (c) 2024 by ${git_name_email}, All Rights Reserved.
 */
/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        :
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/******************************************************************************/
#include "CONFIG.h"
#include "HAL.h"
#include "multiCentral.h"
#include "bsp_uart.h"
#include "bsp_iwdg.h"
#include "bsp_flash.h"
#include "bsp_valve.h"

#undef LOG_ENABLE
#define LOG_ENABLE 1
#include "log.h"
/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__attribute__((aligned(4))) uint32_t MEM_BUF[BLE_MEMHEAP_SIZE / 4];

#if (defined(BLE_MAC)) && (BLE_MAC == TRUE)
const uint8_t MacAddr[6] = {0x84, 0xC2, 0xE4, 0x03, 0x02, 0x02};
#endif

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief
 *
 * @return  none
 */
__HIGH_CODE
__attribute__((noinline)) void Main_Circulation()
{
    while (1)
    {

        TMOS_SystemProcess();

        // BSP_Uart1_Send_Loop();
        BSP_Uart3_Send_Loop();

    }
}

/*********************************************************************
 * @fn      main
 *
 * @brief
 *
 * @return  none
 */
int main(void)
{
#if (defined(DCDC_ENABLE)) && (DCDC_ENABLE == TRUE)
    PWR_DCDCCfg(ENABLE);
#endif
    HSECFG_Capacitance(HSECap_18p);
    SetSysClock(CLK_SOURCE_HSE_PLL_62_4MHz);
#if (defined(HAL_SLEEP)) && (HAL_SLEEP == TRUE)
    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
#endif
#if DEBUG == Debug_UART0
    GPIOA_SetBits(GPIO_Pin_14);
    GPIOPinRemap(ENABLE, RB_PIN_UART0);
    GPIOA_ModeCfg(GPIO_Pin_15, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_14, GPIO_ModeOut_PP_5mA);
    UART0_DefInit();
#elif DEBUG == Debug_UART1
    GPIOB_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
#elif DEBUG == Debug_UART3
    BSP_UART3_Init();
     logDebug("test log debug\n");
#endif

    CH58x_BLEInit();
    HAL_Init();
    GAPRole_CentralInit();
    Central_Init();

    BSP_FLASH_Init();
    BSP_Valve_Init();
    BSP_UART1_Init(); // BT UART
    // IWDG_Init(1000);
    Main_Circulation();
}

/******************************** endfile @ main ******************************/
